﻿/*! \mainpage Danel.Nursing
 *
 * \section Workflows
 *
 * This \is the list of the workflows that exist in the system.
 *
 * \subsection contacts אנשי קשר
 *
 *   \subpage OnContactUpdate
 *      עידכון של איש קשר-תעדכן את הלקוח מקבל שירות בהתאם
 *  
 *   \subpage CopyPickListFromContactToCustomerContactSection
 *     פנימי:העתקת פיקליסת מאיש קשר -למקטע איש קשר ראשי  של הלקוח
 *     
 *   \subpage UpdateAccountGetServiceAccordingToHMOData
 *      עדכן את הלקוח מקבל שירות בהתאם לשדות קופת חולים וכו'
 *      
 *   \subpage CreatePhoneCallTaskOnLeadForControlCenter
 *      (האם תקין) (משל"ט) איתור צורך ליד למשל"ט המשך מעקב-> צור שיחת טלפון
 *      
 *   \subpage TransferLeadToBranch
 *      (תקין) (משל"ט) העברה לסניף - בעידכון סיבת הסטטוס
 */

/*! \page OnContactUpdate OnContactUpdate
 *  \workflowname{OnContactUpdate}
 *  \entity{Contacts}
 *  \available{\no,\no}
 *  \activate{  
 *              \no,
 *              \no,
 *              \no,
 *              \yes
 *              \changes
 *                  - E-mail
 *                  - is main
 *                  - Home phone
 *                  - Cell phone
 *                  - Relation
 *                  - First Name
 *                  - Last Name,
 *              \no
 *           }
 *           
 *  \workflow
 *  \command{\if main contact contains value:, \if Contact: Costumer contains data (\is not null):}
 *  \command{\if the contact \is the main contact update the client (AccountGetService) accordingly, \if Contact: IsMain \is true, 20}
 *  \command{Update the client (AccountGetService),
 *  - Assign Contact as the main contact for the client (AccountGetService)
 *  - Assign Contact's last name to the client's (AccountGetService) main contact last name
 *  - Assign Contact's first name to the client's (AccountGetService) main contact first name
 *  - Assign Contact's cellphone number to the client's (AccountGetService) main contact cellphone number
 *  - Assign Contact's Homephone number to the client's (AccountGetService) main contact Homephone number
 *  - Assign Contact's e-mail to the client's (AccountGetService) main contact e-mail
 *  - Assign \yes to the client's (AccountGetService) \is main contact attribute, 40}
 *  \command{Update relation, Calls \ref CopyPickListFromContactToCustomerContactSection, 20}
 *  \endworkflow
 */

/*! \page CopyPickListFromContactToCustomerContactSection CopyPickListFromContactToCustomerContactSection
 *  \workflowname{OnContactUpdate}
 *  \entity{Contacts}
 *  \available{\no, \yes}
 *  \activate{  
 *              \no,
 *              \no,
 *              \no,
 *              \no,
 *              \no
 *           }
 *           
 *  \workflow
 *  \command{Checks \if the relation equals to father, \if Contact: Relation \is Father:}
 *  \command{Relation \is father, Update client (AccountGetService), 20}
 *  \command{Checks \if the relation equals to sister, Else \if Contact: Relation \is Sister}
 *  \command{Relation \is sister, Update client (AccountGetService), 20}
 *  \command{Checks \if the relation equals to HMO nurse, Else \if Contact: Relation \is HMO Nurse}
 *  \command{Relation \is HMO Nurse, Update client (AccountGetService), 20}
 *  \command{Checks \if the relation equals to Niece, Else \if Contact: Relation \is Niece}
 *  \command{Relation \is Niece, Update client (AccountGetService), 20}
 *  \command{Checks \if the relation equals to Mother, Else \if Contact: Relation \is Mother}
 *  \command{Relation \is Mother, Update client (AccountGetService), 20}
 *  \command{Checks \if the relation equals to Guardian, Else \if Contact: Relation \is Guardian}
 *  \command{Relation \is Guardian, Update client (AccountGetService), 20}
 *  \command{Checks \if the relation equals to Cousin, Else \if Contact: Relation \is Cousin}
 *  \command{Relation \is Cousin, Update client (AccountGetService), 20}
 *  \command{Checks \if the relation equals to Son/Daughter, Else \if Contact: Relation \is Son/Daughter}
 *  \command{Relation \is Son/Daughter, Update client (AccountGetService), 20}
 *  \command{Checks \if the relation equals to Husband/Wife, Else \if Contact: Relation \is Husband/Wife}
 *  \command{Relation \is Husband/Wife, Update client (AccountGetService), 20}
 *  \command{Checks \if the relation equals to Brother/Sister-in-law, Else \if Contact: Relation \is Brother/Sister-in-law}
 *  \command{Relation \is Uncle/Aunt, Update client (AccountGetService), 20}
 *  \command{Checks \if the relation equals to Uncle/Aunt, Else \if Contact: Relation \is Uncle/Aunt}
 *  \command{Relation \is Uncle/Aunt, Update client (AccountGetService), 20}
 *  \command{Checks \if the relation equals to Friend, Else \if Contact: Relation \is Friend}
 *  \command{Relation \is Friend, Update client (AccountGetService), 20}
 *  \command{Checks \if the relation equals to Groom/Bride, Else \if Contact: Relation \is Groom/Bride}
 *  \command{Relation \is Groom/Bride, Update client (AccountGetService), 20}
 *  \command{Checks \if the relation equals to Common-law marriage, Else \if Contact: Relation \is Common-law marriage}
 *  \command{Relation \is Common-law marriage, Update client (AccountGetService), 20}
 *  \command{Checks \if the relation equals to Nurse, Else \if Contact: Relation \is Nurse}
 *  \command{Relation \is Nurse, Update client (AccountGetService), 20}
 *  \command{Checks \if the relation equals to Grandson/Grandaughter, Else \if Contact: Relation \is Grandson/Grandaughter}
 *  \command{Relation \is Grandson/Grandaughter, Update client (AccountGetService), 20}
 *  \command{Checks \if the relation equals to Social Worker, Else \if Contact: Relation \is Social Worker}
 *  \command{Relation \is Social Worker, Update client (AccountGetService), 20}
 *  \command{Checks \if the relation equals to Doctor, Else \if Contact: Relation \is Doctor}
 *  \command{Relation \is Doctor, Update client (AccountGetService), 20}
 *  \command{Checks \if the relation equals to Committee Coordinator, Else \if Contact: Relation \is Social Worker}
 *  \command{Relation \is Committee Coordinator, Update client (AccountGetService), 20}
 *  \command{Checks \if the relation equals to Neighbor, Else \if Contact: Neighbor \is Doctor}
 *  \command{Relation \is Neighbor, Update client (AccountGetService), 20}
 *  \endworkflow
 *  
 *  \todo Refactor this workflow to work on assignment instead of conditions
 *  \workflow
 *  \command{Assign Contact's relation to the Client's main contact relation, Update Client: Relation to Contact: Relation}
 *  \endworkflow
 */

/*! \page UpdateAccountGetServiceAccordingToHMOData UpdateAccountGetServiceAccordingToHMOData
 * 
 *  \workflowname{UpdateAccountGetServiceAccordingToHMOData}
 *  \entity{Home Visits}
 *  \available{\no,\no}
 *  \activate{  
 *              \yes,
 *              \no,
 *              \no,
 *              \yes
 *              \changes
 *                  - \is holocaust survivor
 *                  - HMO Clinic branch
 *                  - HMO company
 *                  - Nursing Doctors,
 *              \no
 *           }
 *  \anchor Bug1
 *  \bug UpdateAccountGetServiceAccordingToHMOData - #1 No-op. Doesn't update anything
 *  \anchor Bug2
 *  \bug UpdateAccountGetServiceAccordingToHMOData - #2 No-op. Doesn't update anything
 *  
 *  \workflow
 *  \command{\if HMO contains value:, \if Home Vist: HMO contains data (\is not null):}
 *  \command{Update the client (AccountGetService), - Assign Home Vist's HMO as the client's HMO (AccountGetService), 20}
 *  \command{Else \if HMO does not contain a value:, Else:}
 *  \command{Update the client (AccountGetService), - Assign null as the client's HMO (AccountGetService), 20}
 *  \command{\if Nursing Doctor contains value:, \if Home Vist: Nursing Doctor contains data (\is not null):}
 *  \command{Update the client (AccountGetService), - Assign Home Vist's Nursing Doctor as the client's Nursing Doctor (AccountGetService), 20}
 *  \command{Else \if HMO does not contain a value:, Else:}
 *  \command{Update the client (AccountGetService), - Assign null as the client's Nursing Doctor (AccountGetService), 20}
 *  \command{\if 'is holocaust survivor' contains value and the value is true:, \if Home Vist: 'is holocaust survivor' contains data (\is not null) \and \is \yes:}
 *  \command{Update the client (AccountGetService), \ref Bug1 "Bug #1" , 20}
 *  \command{\if 'is holocaust survivor' contains value and the value is false:, \if Home Vist: 'is holocaust survivor' contains data (\is not null) \and \is \no:}
 *  \command{Update the client (AccountGetService), \ref Bug2 "Bug #2", 20}
 *  \command{\if HMO Clinic Branch contains value:, \if Home Vist: HMO Clinic Branch contains data (\is not null):}
 *  \command{Update the client (AccountGetService), - Assign Home Vist's HMO Clinic Branch as the client's HMO Clinic Branch (AccountGetService), 20}
 *  \command{Else \if HMO Clinic Branch does not contain a value:, Else:}
 *  \command{Update the client (AccountGetService), - Assign null as the client's HMO Clinic Branch (AccountGetService), 20}
 *  \endworkflow
 */

/*! \page CreatePhoneCallTaskOnLeadForControlCenter CreatePhoneCallTaskOnLeadForControlCenter
 *  \workflowname{CreatePhoneCallTaskOnLeadForControlCenter}
 *  \entity{Lead for control center}
 *  \available{\no,\no}
 *  \activate{  
 *              \yes,
 *              \no,
 *              \no,
 *              \no,
 *              \no
 *           }
 *  \anchor todo1         
 *  \todo Check how the deadline copying behaves
 *           
 *  \workflow
 *  \command{If lead is created create a followup, If Lead For Control Center: Lead Topic is Follow up for a client (AccountGetService):}
 *  \command{Create a followup, Create: Phone Call
 *  - Topic: Followup
 *  - About: Control Center Lead
 *  - Deadline: \ref todo1 "Copies from somewhere. see here", 20}
 *  \endworkflow
 */

/*! \page TransferLeadToBranch TransferLeadToBranch
 *  \workflowname{TransferLeadToBranch}
 *  \entity{Lead for control center}
 *  \available{\no,\yes}
 *  \activate{  
 *              \no,
 *              \no,
 *              \no,
 *              \no
 *              \no,
 *              \no
 *           }
 *           
 *  \workflow
 *  \command{If the lead's status is \value{Transfer to branch}, If Control Center Lead: Status \is \value{Followup} }
 *  \endworkflow
 */

/*! \page Template Template
 *  \workflowname{New Workflow}
 *  \entity{The Entity}
 *  \available{\no,\no}
 *  \activate{  
 *              \no,
 *              \no,
 *              \no,
 *              \yes
 *              \changes
 *                  - Parameters,
 *              \no
 *           }
 *           
 *  \workflow
 *  \command{Description here, Command here}
 *  \endworkflow
 */